#!/usr/bin/perl -w

use strict;

my @fieldnames = qw(PID USER TTY PRI NI %CPU %MEM COMMAND);
my $fmt = cut2fmt(6, 16, 25, 28, 32, 37, 42);

my %fields;
my $badreport;
my $fooey;
my $found;

$badreport = "-----------------------\nliveice watchdog report\n-----------------------\n\nbad liveice/lame pids follow:\n";

open(PS, "ps axwww -o \"pid user tname pri ni %cpu %mem command\" |") || die "can't open ps: $!";
$badreport .= "\n" . scalar <PS>;
while(<PS>) {
  @fields{@fieldnames} = trim(unpack($fmt, $_));
  #if (($fields{TTY} =~ /^pts\/.*/) && ($fields{USER} eq "root")) {
  #if ($fields{USER} eq "root") {
	if ($fields{'COMMAND'} =~ /\.\/liveice/) { 
		$found = 1;
	}
    if ((($fields{"%CPU"} < 1.0) || ($fields{"PRI"} eq "49" )) && (($fields{COMMAND} =~ /^lame.*\.liveice_temp_files/) || ($fields{COMMAND} =~ /liveice <defunct>/))) {
      $fooey++;
      $badreport .= $_;
	  $found = 1;
    }
  #}
}
if (!$found) {
	$badreport = "No liveice processes found at all. CRUD!";
}
if ($fooey || !$found) {
  system("killall liveice > /dev/null 2>&1");
  system("killall -9 liveice > /dev/null 2>&1");
  if (-f '/home/mp3/Archives/daily-archive.mp3') {
	  system("mv /home/mp3/Archives/daily-archive.mp3 /home/mp3/Archives/daily-doh-$$.mp3");
  }
  #system("/usr/bin/screen -m -d bash -c \"cd /usr/local/vibecast/binaries && ./liveice > /tmp/liveice.start\"");
  system("/bin/bash -c 'cd /usr/local/vibecast/binaries && ./liveice' > /dev/null 2> /dev/null &");
  open(SENDMAIL, "|/usr/lib/sendmail -t") || die "can't fork sendmail: $!\n";
  print SENDMAIL <<"EOF";
From: The Vibecast Sanitation Division <nobody\@brentwoodradio.com>
To: the mad diPPer! <dap24\@localhost>
Cc: emm emm tee <mmt\@localhost>
Cc: dap at home <david\@neongoat.com>
Subject: liveice died again :( but i fixed it :)

FROM: The Vibecast Sanitation Division(tm)

Offending procecesses follow:

$badreport

Restarting liveice...

EOF
  close(SENDMAIL) or warn "sendmail is being stubborn";
}

sub cut2fmt {
  my (@positions) = @_;
  my $template = "";
  my $lastpos = 1;
  for my $place (@positions) {
    $template .= "A" . ($place - $lastpos) . " ";
    $lastpos = $place;
  }
  $template .= "A*";
  return $template;
}

sub trim {
  my @strings = @_;
  for (@strings) {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @strings : $strings[0];
}

